#include "xbasic_types.h"
#include "xio.h"
#include "xparameters.h"

#include "xuartlite_l.h"

// for sustained 9600, this handler is called each ~ 833 us 
// the text is in LMB, the data is in OPB (see script)

int uart_no_interrupts;

void uart_handler(void *callback)
{

  Xuint32 IsrStatus;
  
  Xuint8 playwithme;

  uart_no_interrupts++;



  // looking at the status reg, we can see what caused the interrupt
  IsrStatus = XIo_In32(XPAR_MYUART_BASEADDR + XUL_STATUS_REG_OFFSET);
  
  if ((IsrStatus & (XUL_SR_RX_FIFO_FULL | XUL_SR_RX_FIFO_VALID_DATA)) != 0)
    {
     // so the input FIFO contains incoming data : read it
      playwithme = (Xuint8)
	XIo_In32( XPAR_MYUART_BASEADDR + XUL_RX_FIFO_OFFSET);
    }
 
  if ((IsrStatus & XUL_SR_TX_FIFO_EMPTY) != 0)
    {
      // the output FIFO is empty: TO DO : we can send new data
    }
   
}
