-------------------------------------------------------------------------------
-- ak4565_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library opb_xsb300_ak4565_v1_00_a;
use opb_xsb300_ak4565_v1_00_a.all;

entity ak4565_wrapper is
  port (
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    OPB_ABus : in std_logic_vector(31 downto 0);
    OPB_BE : in std_logic_vector(3 downto 0);
    OPB_DBus : in std_logic_vector(31 downto 0);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic;
    UIO_DBus : out std_logic_vector(31 downto 0);
    UIO_errAck : out std_logic;
    UIO_retry : out std_logic;
    UIO_toutSup : out std_logic;
    UIO_xferAck : out std_logic;
    Interrupt : out std_logic;
    AU_CSN_N : out std_logic;
    AU_BCLK : out std_logic;
    AU_MCLK : out std_logic;
    AU_LRCK : out std_logic;
    AU_SDTI : out std_logic;
    AU_SDTO0 : in std_logic
  );
  attribute x_core_info : STRING;
  attribute x_core_info of ak4565_wrapper: entity is "opb_xsb300_ak4565_v1_00_a";

end ak4565_wrapper;

architecture STRUCTURE of ak4565_wrapper is

  component opb_xsb300_ak4565 is
    generic (
      C_OPB_AWIDTH : INTEGER;
      C_OPB_DWIDTH : INTEGER;
      C_BASEADDR : std_logic_vector(31 downto 0);
      C_HIGHADDR : std_logic_vector(31 downto 0)
    );
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(31 downto 0);
      OPB_BE : in std_logic_vector(3 downto 0);
      OPB_DBus : in std_logic_vector(31 downto 0);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      UIO_DBus : out std_logic_vector(31 downto 0);
      UIO_errAck : out std_logic;
      UIO_retry : out std_logic;
      UIO_toutSup : out std_logic;
      UIO_xferAck : out std_logic;
      Interrupt : out std_logic;
      AU_CSN_N : out std_logic;
      AU_BCLK : out std_logic;
      AU_MCLK : out std_logic;
      AU_LRCK : out std_logic;
      AU_SDTI : out std_logic;
      AU_SDTO0 : in std_logic
    );
  end component;

begin

  ak4565 : opb_xsb300_ak4565
    generic map (
      C_OPB_AWIDTH => 32,
      C_OPB_DWIDTH => 32,
      C_BASEADDR => X"FEFE0000",
      C_HIGHADDR => X"FEFEFFFF"
    )
    port map (
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_DBus => OPB_DBus,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr,
      UIO_DBus => UIO_DBus,
      UIO_errAck => UIO_errAck,
      UIO_retry => UIO_retry,
      UIO_toutSup => UIO_toutSup,
      UIO_xferAck => UIO_xferAck,
      Interrupt => Interrupt,
      AU_CSN_N => AU_CSN_N,
      AU_BCLK => AU_BCLK,
      AU_MCLK => AU_MCLK,
      AU_LRCK => AU_LRCK,
      AU_SDTI => AU_SDTI,
      AU_SDTO0 => AU_SDTO0
    );

end architecture STRUCTURE;

