--------------------------------------------------------------------------------
-- videodec_wrapper.vhd
--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

-- synthesis translate_off
LIBRARY UNISIM;
USE UNISIM.VCOMPONENTS.ALL;
-- synthesis translate_on

LIBRARY opb_videodec_v1_00_a;
USE opb_videodec_v1_00_a.ALL;

ENTITY videodec_wrapper IS
PORT (
	-- instance videodec
	IPort : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
	HPort : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
	IDQ : IN STD_LOGIC;
	ICLK : IN STD_LOGIC;
	IPGV : IN STD_LOGIC;
	IPGH : IN STD_LOGIC;
	ITRI : OUT STD_LOGIC;
	ITRDY : OUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO 3);
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO 31);
	OPB_RNW : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqAddr : IN STD_LOGIC;
	VIDEC_DBus : OUT STD_LOGIC_VECTOR(0 TO 31);
	VIDEC_errAck : OUT STD_LOGIC;
	VIDEC_retry : OUT STD_LOGIC;
	VIDEC_toutSup : OUT STD_LOGIC;
	VIDEC_xferAck : OUT STD_LOGIC);
END videodec_wrapper;

ARCHITECTURE IMP OF videodec_wrapper IS

--------------------------------------------------------------------------------
COMPONENT opb_videodec IS
GENERIC (
	C_OPB_AWIDTH : INTEGER := 32;
	C_OPB_DWIDTH : INTEGER := 32;
	C_BASEADDR : STD_LOGIC_VECTOR := X"01800000";
	C_HIGHADDR : STD_LOGIC_VECTOR := X"01803fff");
PORT (
	IPort : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
	HPort : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
	IDQ : IN STD_LOGIC;
	ICLK : IN STD_LOGIC;
	IPGV : IN STD_LOGIC;
	IPGH : IN STD_LOGIC;
	ITRI : OUT STD_LOGIC;
	ITRDY : OUT STD_LOGIC;
	OPB_Clk : IN STD_LOGIC;
	OPB_Rst : IN STD_LOGIC;
	OPB_ABus : IN STD_LOGIC_VECTOR(0 TO C_OPB_AWIDTH-1);
	OPB_BE : IN STD_LOGIC_VECTOR(0 TO C_OPB_DWIDTH/8-1);
	OPB_DBus : IN STD_LOGIC_VECTOR(0 TO C_OPB_DWIDTH-1);
	OPB_RNW : IN STD_LOGIC;
	OPB_select : IN STD_LOGIC;
	OPB_seqAddr : IN STD_LOGIC;
	VIDEC_DBus : OUT STD_LOGIC_VECTOR(0 TO C_OPB_DWIDTH-1);
	VIDEC_errAck : OUT STD_LOGIC;
	VIDEC_retry : OUT STD_LOGIC;
	VIDEC_toutSup : OUT STD_LOGIC;
	VIDEC_xferAck : OUT STD_LOGIC);
END COMPONENT;

--------------------------------------------------------------------------------
-- internal signals
--------------------------------------------------------------------------------

BEGIN

--------------------------------------------------------------------------------
-- Power assignments
--------------------------------------------------------------------------------
-- Constant assignments
--------------------------------------------------------------------------------
-- Top-level port assignments
--------------------------------------------------------------------------------
-- Lower-level assignments

--------------------------------------------------------------------------------
opb_videodec_0_i : opb_videodec
GENERIC MAP (
	C_OPB_AWIDTH => 32,
	C_OPB_DWIDTH => 32,
	C_BASEADDR => X"01800000",
	C_HIGHADDR => X"01803fff")
PORT MAP (
	IPort => IPort,
	HPort => HPort,
	IDQ => IDQ,
	ICLK => ICLK,
	IPGV => IPGV,
	IPGH => IPGH,
	ITRI => ITRI,
	ITRDY => ITRDY,
	OPB_Clk => OPB_Clk,
	OPB_Rst => OPB_Rst,
	OPB_ABus => OPB_ABus,
	OPB_BE => OPB_BE,
	OPB_DBus => OPB_DBus,
	OPB_RNW => OPB_RNW,
	OPB_select => OPB_select,
	OPB_seqAddr => OPB_seqAddr,
	VIDEC_DBus => VIDEC_DBus,
	VIDEC_errAck => VIDEC_errAck,
	VIDEC_retry => VIDEC_retry,
	VIDEC_toutSup => VIDEC_toutSup,
	VIDEC_xferAck => VIDEC_xferAck);

END ARCHITECTURE IMP;
