//-----------------------------------------------------------------------------
// CSEE 4840 Embedded System Design
// Jaycam
// Yaniv Schiller - yhs2001@columbia.edu
// Avrum Tilman - amt77@columbia.edu
// Josh Weinberg - jmw211@columbia.edu
//-----------------------------------------------------------------------------


module clkgen(
FPGA_CLK1,

sys_clk,
pixel_clock,
io_clock,
fpga_reset

);

input FPGA_CLK1;
output sys_clk, pixel_clock, io_clock, fpga_reset;


wire clk_ibuf, clk1x_i, clk2x_i;
wire locked;

assign pixel_clock = 0;

IBUFG clkibuf(.I(FPGA_CLK1), .O(clk_ibuf));
BUFG bg1 (.I(clk1x_i), .O(sys_clk));
BUFG bg2 (.I(clk2x_i), .O(io_clock));

// synopsys translate_off
// synopsys translate_on
CLKDLL vdll(.CLKIN(clk_ibuf), .CLKFB(sys_clk),
	 .CLK0(clk1x_i),
	 .CLK2X(clk2x_i),
	 .RST(1'b0), .LOCKED(locked)
);

assign fpga_reset = ~locked;


endmodule
